#!/usr/local/bin/perl -w

use CGI qw(:all);
use CGI::Carp;

my $c = param('c');  # container
my $invalid;

if (defined $c) {
	$c = cleanContainer($c);
	$invalid = validate($c);
}

if (! defined($c) || defined($invalid))  {

  print header();
  print << "%%";

<body>

<h1>Google Earth Container Tracker</h1>

<!-- Nifty, but not needed now that we just use track-trace.com
	and put in container numbers
<script>
function setprompt(s) {
  var s = document.getElementById('sel');
  var d = document.getElementById('prompt');
  var p = '';
  if (s.value == 'APL') {
    p = 'Bill of lading number:'
  } else if (s.value == 'Delmas') {
    p = 'Container number:'
  }
  d.innerHTML = p;
}
</script>
-->

<p>
<form>
<table>

<tr><td><div id="prompt">Container number</div>
<td><input type=text size=40 name="c">
</table>
</form>
%%

print "<p style=\"color: red\">$invalid</p>"
	if (defined($invalid));

print << '%%';
<p>
At this point, the demo is only <b>known</b> to work with
these containers:
<ul>
<li>TCKU2854015
<li>PONU0522000
<li>PONU2017517
<li>TEXU2537636
<li>NYKU8210506
</ul>

<p>
Other input is likely
to cause it to fail in mysterious ways, because
this is just a prototype.

<p>
The files that make this thing work are <a href="track.zip">here</a>.
You can also see the <a href="README.txt">README</a> without unpacking
the zip file. These files are placed in the public domain, and may
be used by anyone as a basis of any future project. Jeff R. Allen,
June 8, 2006.
%%

  exit;
}

print header(-type => 'application/vnd.google-earth.kml+xml',
	'-Content-disposition' => 'attachment; filename=track.kml'
);

# make the new URL by editing out current one
my $me = self_url();
$me =~ s/(index.cgi)?\?/track.cgi?/;

print << "%%"
<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.0">
<NetworkLink>
  <name>Tracking container $c </name>
  <visibility>1</visibility>
  <Url>
    <href>$me</href>
    <refreshMode>onInterval</refreshMode>
    <refreshInterval>86404</refreshInterval>
    <viewRefreshMode>onRequest</viewRefreshMode>
  </Url>
</NetworkLink>
</kml>
%%
;

# make sure it is not undef,
# then uppercase it,
# then remove all things which are not numbers and letters.
sub cleanContainer {
	my($c) = $_[0] || '';
	$c = uc($c);
	$c =~ s/[^A-Z0-9]//;
	return $c;
}

# already cleaned, so guaranteed to be close to right format
# not undef, num/let only.
sub validate {
	my($c) = @_;

	if (length($c) != 11) {
		return "Container numbers should be exactly 11 characters long."
	}
	if ($c !~ /^[A-Z]{4}.......$/) {
		return "Container numbers should start with exactly 4 letters."
	}
	if ($c !~ /^....[0-9]{7}$/) {
		return "Container numbers should end with exactly 7 numbers."
	}

	# no errors, yay
	return undef;
}
